/*
 mbuffer -- buffer module
 Copyright (c) 2005,2006 Hitachi,Ltd.,
 Created by Satoru Moriya <s-moriya@sdl.hitachi.co.jp>
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __MBUFFER_H__
#define __MBUFFER_H__

#include "ctr.h"
#include "kstrax_ioc.h"

/*
 *  function declaration
 */
int init_mbuffer(int);
void clear_mbuffer(void);
int kstrax_init_status(int);
int kstrax_reset_index(void);
int kstrax_read_basetime(int *);
int kstrax_copy_status(trace_stat_t *);
int kstrax_pid_spec(pid_t);
int kstrax_syscall_spec(int);
int kstrax_set_current_index(void);
ssize_t kstrax_read(struct file *, char __user *, size_t, loff_t *);

void pre_sys_call_record(const ctr_handler_t);
void post_sys_call_record(const ctr_handler_t);

#endif /* __MBUFFER_H__ */
